package betterwithmods.common.entity.ai;

import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;

import java.util.List;
import java.util.function.Predicate;

/**
 * Created by tyler on 4/22/17.
 */
public class EntityAIEatFood extends EntityAIBase {
    private EntityCreature entity;
    private Predicate<ItemStack> validItem;
    private EntityItem targetItem;
    private int timeoutCounter;

    public EntityAIEatFood(EntityCreature creature, Predicate<ItemStack> validItem) {
        this.entity = creature;
        this.validItem = validItem;
    }

    public EntityItem getTargetItem(List<EntityItem> items) {
        if (items.isEmpty())
            return null;
        EntityItem target = null;
        for (EntityItem item : items) {
            if (validItem.test(item.func_92059_d())) {
                target = item;
                break;
            }
        }
        return target;
    }

    @Override
    public void func_75249_e() {
        this.entity.func_70661_as().func_75492_a(targetItem.field_70165_t, targetItem.field_70163_u, targetItem.field_70161_v, 1.0F);
    }

    @Override
    public boolean func_75250_a() {
        BlockPos entityPos = entity.func_180425_c();
        if (targetItem == null) {
            List<EntityItem> entityItems = entity.func_130014_f_().func_72872_a(EntityItem.class, new AxisAlignedBB(entityPos, entityPos.func_177982_a(1, 1, 1)).func_72321_a(5, 5, 5));
            targetItem = getTargetItem(entityItems);
        }
        if (targetItem != null) {
            BlockPos targetPos = targetItem.func_180425_c();
            if (entityPos.func_185332_f(targetPos.func_177958_n(), targetPos.func_177956_o(), targetPos.func_177952_p()) <= 2D && targetItem.func_92059_d().func_190916_E() > 0) {
                processItemEating();
                return false;
            } else {
                return true;
            }
        }
        return false;
    }

    @Override
    public boolean func_75253_b() {
        if (targetItem.field_70128_L || targetItem.func_92059_d().func_190916_E() < 1) {
            BlockPos entityPos = entity.func_180425_c();
            List<EntityItem> entityItems = entity.func_130014_f_().func_72872_a(EntityItem.class, new AxisAlignedBB(entityPos, entityPos.func_177982_a(1, 1, 1)).func_72321_a(5, 5, 5));
            targetItem = getTargetItem(entityItems);
        }
        if (targetItem == null || targetItem.field_70128_L)
            return false;
        if (timeoutCounter > 1200)
            return false;
        if (!this.entity.func_70661_as().func_75500_f()) {
            double sqDistToPos = this.entity.func_70092_e(targetItem.field_70165_t, targetItem.field_70163_u, targetItem.field_70161_v);
            if (sqDistToPos > 2.0D)
                return true;
        }
        return false;
    }

    /**
     * Updates the task
     */
    @Override
    public void func_75246_d() {
        if (entity.func_70092_e(targetItem.field_70165_t, targetItem.field_70163_u, targetItem.field_70161_v) <= 2.0D && targetItem.func_92059_d().func_190916_E() > 0) {
            processItemEating();
        } else {
            ++timeoutCounter;
            if (timeoutCounter % 40 == 0) {
                this.entity.func_70661_as().func_75492_a(targetItem.field_70165_t, targetItem.field_70163_u, targetItem.field_70161_v, 1.0F);
            }
        }
    }
    private void processItemEating() {
        ItemStack foodStack = targetItem.func_92059_d().func_77979_a(1);
        entity.func_184185_a(SoundEvents.field_187739_dZ, 1.0F, (entity.field_70170_p.field_73012_v.nextFloat() - entity.field_70170_p.field_73012_v.nextFloat()) * 0.2F + 1.0F);
        foodStack.func_190918_g(1);
    }
}
